apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ rspamd_name }}
  name: {{ rspamd_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ rspamd_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ rspamd_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ rspamd_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ rspamd_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ rspamd_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ rspamd_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: CONTROLLER_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ rspamd_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HEADER_SCORE
          value: "{{ rspamd_add_header_threshold }}"
        - name: REDIS_DATABASE
          value: "1"
        - name: REDIS_HOST
          value: {{ cache_name }}-proxy
        - name: SENTINEL_HOST
          value: ""
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='rspamd'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='rspamd'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          httpGet:
            path: /
            port: 11334
          periodSeconds: 15
          timeoutSeconds: 3
        name: rspamd
        ports:
        - containerPort: 11332
          name: proxy
        - containerPort: 11333
          name: normal
        - containerPort: 11334
          name: controller
        readinessProbe:
          httpGet:
            path: /
            port: 11334
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ rspamd_cpu_limit }}"
            memory: "{{ rspamd_memory_limit }}"
          requests:
            cpu: "{{ rspamd_cpu_request }}"
            memory: "{{ rspamd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/lib/rspamd
          name: var
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ rspamd_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: var
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='rspamd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - rspamd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='rspamd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
